#include "standard.h"

#include "nc.h"
#include "nd.h"
#include "temp.h"



ostream& operator<<(ostream& s, const Bound_Det_Manip<Rev_Nd>& bdm)
{
	stringstream ss;
	switch (bdm.det_manip().level())
	{
	case 0:
		ss << bdm.data()->id();
		break;
	default:
		ss << bdm.data()->to_tree_output_string();
		break;
	}

	return s << ss.str();
}
	
	

ostream& operator<<(ostream& s, const Bound_Det_Manip<Rev_NC>& bdm)
{
	stringstream ss;
	int level = bdm.det_manip().level();
	const Rev_NC* n = bdm.data();
	
	const Base_NC<Rev_Nd, Rev_NC, Rev_Intern_NC, Rev_Tree>* b
		= static_cast<const Base_NC<Rev_Nd, Rev_NC, Rev_Intern_NC, Rev_Tree>* >(n);
	
	//ss << Det_Manip<Base_NC<Rev_Nd, Rev_NC, Rev_Intern_NC, Rev_Tree> >(level)(b);

	switch (level)
	{
	case 0:
		ss << bdm.data()->str_id();
		break;
	default:
		ss << bdm.data()->str_id();
		ss << "*** Rev_NC ***" << endl;
		ss << "next_old: " << n->m_next_old << endl;
		ss << "prev_old: " << n->m_prev_old << endl;
		ss << "is_pos_affected: " << n->m_is_pos_affected << endl;
		ss << "is_time_affected: " << n->m_is_time_affected << endl;
		ss << "is_nd_st_affected: " << n->m_is_nd_st_affected << endl;
		ss << "birth_time_old: " << n->m_birth_time_old << endl;
		ss << "old_num_elig_nodes: " << n->m_old_num_elig_nodes << endl;
		ss << "old_num_cum_elig_sites: " << n->m_old_num_cum_elig_sites << endl;
		ss << "m_mark: " << n->m_mark << endl;
		break;
	}

	return s << ss.str();
}
