#include "standard.h"

#include "classftn.h"
#include "MCMC.h"
#include "return.h"



ostream& operator<<(ostream& s, const Return& ret)
{
	s << ret.mcmc_results << flush;
	const Classftn& cls = ret.cls;

	// output sequences
	s << ">seqs   # (number of tip, type of tip (pure/crf), number of sub/crf)" << endl;
	for (int i = 0; i < cls.num_tips(); ++i)
		s << i << " " << cls.tip(i);

	// output breakpoints
	s << ">bps   # breakpoints of crfs" << endl;
	for (int i = 0; i < cls.num_crfs(); ++i) {
		for (int j = 0; j < cls.num_bps(i); ++j)
			s << setw(4) << left << cls.bp(i, j) << " ";
		s << endl;
	}

	// output subtypes of segments
	s << ">segms   # segments of crfs" << endl;
	for (int i = 0; i < cls.num_crfs(); ++i) {
		for (int j = 0; j < cls.num_segms(i); ++j)
			s << setw(2) << left << cls.segm_sub(i, j) << " ";
		s << endl;
	}

	s << ">end" << endl;
	return s;
}
