#ifndef RETURN_H_
#define RETURN_H_

#include "standard.h"

class Classftn;



/**
 * Return encapsulates the results of an MCMC run and the used classification in order to print
 * them in a matter such that Perl can process it
 */
struct Return
{
	friend ostream& operator<<(ostream& s, const Return& ret);
	const MCMC::Results& mcmc_results;
	const Classftn& cls;
	Return(const MCMC::Results& p_mcmc_results, const Classftn& p_cls)
	: mcmc_results(p_mcmc_results), cls(p_cls) { }
};

ostream& operator<<(ostream& s, const Return& ret);

#endif
