#ifndef TIP_SEQS_H
#define TIP_SEQS_H

#include "standard.h"



struct Seq
{
	string name;
	string genome;
};



class Tip_Seqs
{
	friend ostream& operator<<(ostream& s, const Tip_Seqs& ts);
private:
	static const int DEFAULT_NUM_SITES = 4;
	int m_num_sites;
	int m_num_tips;
	VECTOR(Seq) m_seq_of_tips;
	static LoggerPtr s_logger;

	static LoggerPtr& logger() { return s_logger; }
public:
	Tip_Seqs(string filename);
	Tip_Seqs(VECTOR(string) seqs);
	Tip_Seqs(const int i, const int num_sites_para = DEFAULT_NUM_SITES);

	string name(int i) const { return m_seq_of_tips[i].name; }
	string genome(int i) const { return m_seq_of_tips[i].genome; }
	int num_sites() const { return m_num_sites; }
	int num_tips() const { return m_num_tips; }

	void save(string filename) const;
};

ostream& operator<<(ostream& s, const Tip_Seqs& ts);

#endif
