#ifndef JPHMM_H
#define JPHMM_H

#include "standard.h"

using namespace std;

class Classftn;
class Tip_Seqs;



namespace jpHMM_impl {
	struct Segm
	{
		int begin, end, sub;
		BOOL is_defined;
	};
}



class jphmm
{
	friend ostream& operator<<(ostream& s, const jphmm& cls);
private:
	VECTOR(jpHMM_impl::Segm) m_segments;
	string m_query_seq;
	static BOOL s_alignmt_file_generated;
	static LoggerPtr s_logger;
	
	static LoggerPtr& logger() { return s_logger; }
	BOOL alignmt_file_generated() const { return s_alignmt_file_generated; }
	void calc_bps();
public:
	jphmm(const string query_seq);

	int begin(int i) const { return m_segments.at(i).begin; }
	int end(int i) const { return m_segments.at(i).end; }
	int sub(int i) const { return m_segments.at(i).sub; }
	BOOL is_crf() const { return (m_segments.size() > 1); }
	int sub() const;   // get the only occuring sub if there is only one
	int size() const { return m_segments.size(); }
	static void gen_algnmt_file(const Tip_Seqs* tip_seqs, const Classftn* cls);
};

ostream& operator<<(ostream& s, const jphmm& cls);

#endif
