#ifndef CONSTS_H_
#define CONSTS_H_

#include "standard.h"

#include "alphabet.h"

const int NUM_NUCL = 4;

class simple_tree;



class Constants
{
	friend double aux_optim_para (double x, void *params);
	friend void optim_para(simple_tree* tr);
private:
	Constants();

	static Constants* m_instance;

	// evolution parameter
	double m_recomb_const;
 	double m_theta;
 	double m_alpha;
 	int m_num_mutation_rates;
	VECTOR(double) m_prob_mutation_rates;
	VECTOR(double) m_base_probs;
	// program control
	double m_jump_prob;
	BOOL m_use_jphmm;
	BOOL m_use_unknown_segms;
	// administrative
	BOOL m_messages_on;
	BOOL m_use_common_output_file;
	BOOL m_delete_spec_output_file;
	int m_appl_id;
	BOOL m_single_arg_file;
	BOOL m_compile_dot;
	BOOL m_compile_dot_immediately;
	BOOL m_compile_sim_tree;
	BOOL m_compile_best_tree;
	BOOL m_use_scratch;
	// other
	Alphabet m_alphabet;
public:
	// evolution parameter
	double& recomb_const() { return m_recomb_const; }
	double& theta() { return m_theta; }
	double& alpha() { return m_alpha; }
	int num_mutation_rates() { return m_num_mutation_rates; }
	double prob_mutation_rate(const int i) { return m_prob_mutation_rates[i]; }
	double base_prob(const int i) { return m_base_probs[i]; }
	// program control
	double& jump_prob() { return m_jump_prob; }
	BOOL& use_jphmm() { return m_use_jphmm; }
	// administrative
	BOOL& messages_on() { return m_messages_on; }
	BOOL& use_common_output_file() { return m_use_common_output_file; }
	BOOL& delete_spec_output_file() { return m_delete_spec_output_file; }
	int& appl_id() { return m_appl_id; }
	BOOL& single_arg_file() { return m_single_arg_file; }
	BOOL& compile_dot() { return m_compile_dot; }
	BOOL& compile_dot_immediately() { return m_compile_dot; }
	BOOL& compile_sim_tree() { return m_compile_sim_tree; }
	BOOL& compile_best_tree() { return m_compile_best_tree; }
	BOOL& use_scratch() { return m_use_scratch; }
	// other
	Alphabet& alphabet() { return m_alphabet; }

	static Constants* instance();
};



#endif
