#ifndef PRT_ND_CONN_H
#define PRT_ND_CONN_H

#include "standard.h"

#include "files.h"





class Conn_Point
{
	friend ostream& operator<<(ostream& s, const Conn_Point& cp);
private:
	int m_id;
	BOOL m_is_coal;
	set<int> m_subs;
	set<int> m_first_subs;
	set<int> m_second_subs;
public:
	Conn_Point(int id, BOOL is_coal, const set<int>& subs, const set<int>& first_subs, const set<int>& second_subs);

	int id() const { return m_id; }
	BOOL is_coal() const { return m_is_coal;}
	int sub() const;
	const set<int>& subs() const { return m_subs; }
	const set<int>& first_subs() const;
	const set<int>& second_subs() const;
};

ostream& operator<<(ostream& s, const Conn_Point& cp);



class Part_Node_Conn
{
	friend ostream& operator<<(ostream& s, const Part_Node_Conn& n);
private:
	VECTOR(Conn_Point) m_conn_points;
public:
	void push_back(int id, BOOL is_coal, const set<int>& subs,
            	   const set<int>& first_subs, const set<int>& second_subs);
	void push_back(const int id, const int sub);
	void pop_back();
	const Conn_Point& back() const;
	const VECTOR(Conn_Point)& conn_points() const { return m_conn_points; }
	int size() const { return m_conn_points.size(); }
};

ostream& operator<<(ostream& s, const Part_Node_Conn& n);

#endif
