#ifndef ERROR_H_
#define ERROR_H_

#include "standard.h"

using namespace log4cxx;
using namespace std;

#define ERROR(logger, message) Error(logger, __FILE__, __FUNCTION__, __LINE__, message)
#define OUT_FNCTN_HEADER(logger) output_function_header(logger, __FILE__, __FUNCTION__, __PRETTY_FUNCTION__)
#define OUT_FNCTN_BOTTOM(logger) output_function_bottom(logger, __FILE__, __FUNCTION__, __PRETTY_FUNCTION__)



class Error
{
	friend ostream& operator<<(ostream& s, const Error& err);
private:
	string m_message;
	string m_file_name;
	string m_function_name;
	int m_no_line;
public:
	Error(const string& str) : m_message(str) { cout << message() << endl; }
	Error(LoggerPtr logger, const string& file_name, const string& function_name, int no_line, const string& msg);

	string message() const { return m_message; }
	string file_name() const { return m_file_name; }
	string function_name() const { return m_function_name; }
	int no_line() const { return m_no_line; }
};

ostream& operator<<(ostream& s, const Error& err);



void output_function_header(LoggerPtr logger, const string& file_name, const string& function_name, const string& det_fnctn_name);
void output_function_bottom(LoggerPtr logger, const string& file_name, const string& function_name, const string& det_fnctn_name);

#endif
