#ifndef ALPHABET_H_
#define ALPHABET_H_

#include "standard.h"

#include "control_consts.h"



class Alphabet
{
	friend ostream& operator<<(ostream& s, const Alphabet& al);
private:
	VECTOR(char) m_characters;
	map<char, int> m_char_to_idx;
	BOOL m_is_init;
	static LoggerPtr s_logger;

	LoggerPtr& logger() const { return s_logger; }
public:
	Alphabet() { }

	void init(VECTOR(char) characters);

	char character(int i) const;
	string characters(VECTOR(int) v) const;
	int idx(char c) const;
	VECTOR(int) indices(string s) const;
	BOOL is_legal_character(char c) const { return ((m_char_to_idx.find(c) != m_char_to_idx.end()) ? true : false); }
	BOOL is_legal_idx(int i) const { return (((i >= 0) && (i < m_characters.size())) ? true : false); }
	BOOL is_legal_indices(VECTOR(int) v) const;

	void check() const;
};



ostream& operator<<(ostream& s, const Alphabet& al);

#endif
