#include "standard.h"

#include "base_nc_def.h"
#include "nc.h"
#include "nd.h"
#include "sim_nc.h"
#include "sim_nd.h"
#include "sim_tree.h"
#include "tree.h"

using namespace std;



// Reversible node container
template class Base_NC<Rev_Nd, Rev_NC, Rev_Intern_NC, Rev_Tree>;

template class NC_with_Nds<Rev_Nd, Rev_Tip_Nd, Rev_NC, Rev_Intern_NC, Rev_Tree>;
template class NC_with_Nds<Rev_Nd, Rev_Coal_Nd, Rev_NC, Rev_Intern_NC, Rev_Tree>;
template class NC_with_Nds<Rev_Nd, Rev_Rec_Nd, Rev_NC, Rev_Intern_NC, Rev_Tree>;
template class NC_with_1_Nd<Rev_Nd, Rev_Tip_Nd, Rev_NC, Rev_Intern_NC, Rev_Tree>;
template class NC_with_1_Nd<Rev_Nd, Rev_Coal_Nd, Rev_NC, Rev_Intern_NC, Rev_Tree>;
template class NC_with_2_Nds<Rev_Nd, Rev_Rec_Nd, Rev_NC, Rev_Intern_NC, Rev_Tree>;

template class Tip_NC<Rev_Nd, Rev_Tip_Nd, Rev_NC, Rev_Intern_NC, Rev_Tree>;
template class Intern_NC<Rev_Intern_NC>;
template class Coal_NC<Rev_Nd, Rev_Coal_Nd, Rev_NC, Rev_Coal_NC, Rev_Intern_NC, Rev_Tree>;
template class Rec_NC<Rev_Nd, Rev_Rec_Nd, Rev_NC, Rev_Rec_NC, Rev_Intern_NC, Rev_Tree>;


// Simulation node container
template class Base_NC<Sim_Nd, Sim_NC, Sim_Intern_NC, Sim_Tree>;

template class NC_with_Nds<Sim_Nd, Sim_Tip_Nd, Sim_NC, Sim_Intern_NC, Sim_Tree>;
template class NC_with_Nds<Sim_Nd, Sim_Coal_Nd, Sim_NC, Sim_Intern_NC, Sim_Tree>;
template class NC_with_Nds<Sim_Nd, Sim_Rec_Nd, Sim_NC, Sim_Intern_NC, Sim_Tree>;
template class NC_with_1_Nd<Sim_Nd, Sim_Tip_Nd, Sim_NC, Sim_Intern_NC, Sim_Tree>;
template class NC_with_1_Nd<Sim_Nd, Sim_Coal_Nd, Sim_NC, Sim_Intern_NC, Sim_Tree>;
template class NC_with_2_Nds<Sim_Nd, Sim_Rec_Nd, Sim_NC, Sim_Intern_NC, Sim_Tree>;

template class Tip_NC<Sim_Nd, Sim_Tip_Nd, Sim_NC, Sim_Intern_NC, Sim_Tree>;
template class Intern_NC<Sim_Intern_NC>;
template class Coal_NC<Sim_Nd, Sim_Coal_Nd, Sim_NC, Sim_Coal_NC, Sim_Intern_NC, Sim_Tree>;
template class Rec_NC<Sim_Nd, Sim_Rec_Nd, Sim_NC, Sim_Rec_NC, Sim_Intern_NC, Sim_Tree>;


