#ifndef LOG_ACID_PROB_H_
#define LOG_ACID_PROB_H_

#include "standard.h"

using namespace std;



class Log_Acid_Prob
{
	friend ostream& operator<<(ostream& s, const Log_Acid_Prob& lap);
private:
	static int m_count_id;
	int m_id;
	VECTOR( VECTOR(double) ) m_log_p;
	VECTOR( VECTOR(double) ) m_log_p_anc;
	static LoggerPtr s_logger;

	LoggerPtr& logger() const { return s_logger; }
public:
	Log_Acid_Prob (const VECTOR( VECTOR(double) )* log_p);
	Log_Acid_Prob (const int i);
	Log_Acid_Prob (const Log_Acid_Prob& lap);

	int id() const { return m_id; }
	double& log_p(const int mut_rate, const int acid) { return m_log_p[mut_rate][acid]; }
	double& log_p_anc(const int mut_rate, const int acid) { return m_log_p_anc.at(mut_rate).at(acid); }
	const VECTOR( VECTOR(double) )* log_p_anc() const { return &m_log_p_anc; }
};

ostream& operator<<(ostream& s, const Log_Acid_Prob& lap);

#endif
