#ifndef PARENT_VISITORS_H_
#define PARENT_VISITORS_H_

#include "standard.h"

using namespace std;
using namespace boost;



template<class CC, class RC> class Time_of_Parent_Visitor : public static_visitor<double>
{
public:
	double operator()(CC* c) const { return c->birth_time(); }
    double operator()(RC* c) const { return c->birth_time(); }
    double operator()(Empty e) const { throw Error("Trying to get time of parent of node having none"); }
};



template<class CN, class CC, class RC> class Parent_Node_Visitor : public static_visitor<CN*>
{
public:
    CN* operator()(CC* c) const;
    CN* operator()(RC* c) const { throw Error("Trying to get parent of node having two parents"); }
    CN* operator()(Empty e) const { throw Error("Trying to get parent of node having none"); }
};



template<class RN, class CC, class RC> class First_Parent_Node_Visitor : public static_visitor<RN*>
{
public:
    RN* operator()(CC* c) const { throw Error("Trying to get first parent of node having one parent"); }
    RN* operator()(RC* c) const;
    RN* operator()(Empty e) const { throw Error("Trying to get parent of node having none"); }
};



template<class RN, class CC, class RC> class Second_Parent_Node_Visitor : public static_visitor<RN*>
{
public:
    RN* operator()(CC* c) const { throw Error("Trying to get second parent of node having one parent"); }
    RN* operator()(RC* c) const;
    RN* operator()(Empty e) const { throw Error("Trying to get parent of node having none"); }
};



template<class CC, class RC, class PC> class Parent_Contnr_Visitor : public static_visitor<PC*>
{
public:
    PC* operator()(CC* c) const { return c; }
    PC* operator()(RC* c) const { return c; }
    PC* operator()(Empty e) const { throw Error("Trying to get parent container of node having none"); }
};



template<class CC, class RC, class PC> class Coal_Parent_Contnr_Visitor : public static_visitor<CC*>
{
public:
    CC* operator()(CC* c) const { return c; }
    CC* operator()(RC* c) const { throw Error("Trying to get coal parent container of node having recomb parent container"); }
    CC* operator()(Empty e) const { throw Error("Trying to get parent container of node having none"); }
};



template<class CC, class RC, class PC> class Rec_Parent_Contnr_Visitor : public static_visitor<RC*>
{
public:
    RC* operator()(CC* c) const { throw Error("Trying to get coal parent container of node having recomb parent container"); }
    RC* operator()(RC* c) const { return c; }
    RC* operator()(Empty e) const { throw Error("Trying to get parent container of node having none"); }
};



#include "parent_visitors.imp"

#endif 
