#ifndef TR_PROB_H
#define TR_PROB_H

#include "standard.h"

using namespace std;

class Rev_Nd;



class S_and_P
{
public:
	static const int num_S = 6;
	enum Nds_Left { NONE_LEFT, FIRST_LEFT, SECOND_LEFT, THIRD_LEFT, ALL_LEFT, FIRST_TWO_LEFT };
private:
	VECTOR(double) m_s;
	map<pair<Nds_Left, Nds_Left>, double> m_p;   // transition prob between states describing which children are left
	VECTOR(int) m_elig_sites;
	VECTOR(double) m_q;   // transition prob from ALL_LEFT to NONE_LEFT via index (= FIRST_LEFT or SECOND_LEFT or THIRD_LEFT)
	Nds_Left m_index;   // state describing which children are left
	BOOL m_elig_sites_init;
	static LoggerPtr s_logger;

	static LoggerPtr& logger() { return s_logger; }
	double calc_P(int j, int i, VECTOR(int) l, int z, double t);
public:

	S_and_P() { m_s.resize(num_S); m_q.resize(3); }

	void calc_trans_prob(int z, double t);
	void calc_elig_sites(const int curr_elig_sites, VECTOR(Rev_Nd*) children);
	double q(const int i) const { return m_q[i]; }
	double P(const Nds_Left before, const Nds_Left after) const;
	double P(const int before, const int after) const { return P((Nds_Left)before, (Nds_Left)after); }
	double S(const int i) const { return m_s[i]; }
	double& S(const int i) { return m_s[i]; }
	Nds_Left index() const { return m_index; }
	Nds_Left& index() { return m_index; }
	int elig_sites(const int i) const { return m_elig_sites[i]; }
	int& elig_sites(const int i) { return m_elig_sites[i]; }
	void set_S_to_start(const BOOL start_at_second_child);
	void jump();
};

#endif
