#ifndef RVEC_H_
#define RVEC_H_

#include "control_consts.h"

#include <vector>
#include <list>

using namespace std;



template<class T> class Range_checked_Vector : public vector<T>
{
private:
public:
	Range_checked_Vector() : vector<T>() { }
	Range_checked_Vector(int s) : vector<T>(s) { }
	Range_checked_Vector(int s, T t) : vector<T>(s, t) { }
	Range_checked_Vector(typename vector<T>::iterator it, typename vector<T>::iterator jt) : vector<T>(it, jt) { }
	Range_checked_Vector(typename list<T>::iterator it, typename list<T>::iterator jt) : vector<T>(it, jt) { }
	Range_checked_Vector(T* p, T* q) : vector<T>(p, q) { }

	using vector<T>::at;

    T& operator[](int i) { return at(i); }
    const T& operator[](int i) const { return at(i); }
};



#ifdef SAFE
	#define VECTOR(x) Range_checked_Vector<x>
#else
	#define VECTOR(x) vector<x>
#endif

#endif
