#ifndef DECOMP_H
#define DECOMP_H

#include "standard.h"

using namespace std;



class Decomposition
{
	friend ostream& operator<<(ostream& s, const Decomposition& dcmp);
private:
	gsl_matrix* m_T;
	gsl_matrix*	m_inv_T;
	VECTOR(double) m_eig_val;
public:
	const gsl_matrix& T() const { return *m_T; }
	const gsl_matrix& inv_T() const { return *m_inv_T; }
	const VECTOR(double)& eig_val() const { return m_eig_val; }
	
	Decomposition();
	~Decomposition();
};

ostream& operator<<(ostream& s, const Decomposition& dcmp);

#endif
