#ifndef SIM_TREE_H_
#define SIM_TREE_H_

#include "standard.h"

#include "base_tree_def.h"

class Rev_Tree;
class Sim_Coal_Nd;
class Sim_Rec_Nd;



class Sim_Tree : public Base_Tree<Sim_Nd, Sim_Coal_Nd, Sim_Rec_Nd, Sim_NC>
{
private:
	BOOL m_is_mut_rate_const;
	static LoggerPtr m_logger;

	static LoggerPtr& logger() { return m_logger; }
public:
	Sim_Tree(const int num_sites, const int num_mutation_rates);
	Sim_Tree(const Rev_Tree& tr);
	~Sim_Tree();

	void generate();
	VECTOR(string) sim_seq(const BOOL is_mut_rate_const);
	virtual double log_prior_prob();
	BOOL is_mut_rate_const() const { return m_is_mut_rate_const; }
	void check_node_contnr() const;
	void check() const;
};

ostream& operator<<(ostream& s, const Sim_Tree& tr);



void optim_para(Sim_Tree* tr);

#endif
