/**************************************************************
 file   	: CONST_DEF.CC
 licence        : GNU Licence, see file LICENCE
 description    : -> const_def.hh
 author		: Anne-Kathrin Schultz, anne@gobics.de
 date		: 12.03.04


  |   date    |    author            |  changes
 -|-----------|----------------------|-------------------------------
  | 31.05.05  | Anne-Kathrin Schultz | general_Alphabet added

***************************************************************/

#include "const_def.hh"
#include <fstream>
#include <iostream>
#include <cstdlib>

using namespace std;


int Const_Def::indexOfAlphabet[256];


/*******************************************************\

 *                 class Const_Def                     *

\*******************************************************/

//--------------------------------------------------------------------------------------------------
// Const_Def()
//
//    calls function fill_Alphabet()
//-------------------------------------------------------------------------------------------------- 
Const_Def::Const_Def() {
  fillAlphabet();
}

//--------------------------------------------------------------------------------------------------  
// initialize(): 
//
//    Initialization of each entry by -1 
//-------------------------------------------------------------------------------------------------- 
void Const_Def::initialize() {
  for (int i=0; i<256; i++)
    indexOfAlphabet[i] = -1; 
}

//--------------------------------------------------------------------------------------------------
// fillAlphabet(): 
//
//    assigns the corresponding position in the alphabet to all characters contained in the alphabet
//--------------------------------------------------------------------------------------------------
void Const_Def::fillAlphabet() {
  
  initialize();
  if (alphabet == protein) {
    for (int j=0; j<NUM_AA+NUM_GAPS+1; j++) {
      indexOfAlphabet[(int) amino[j]] = j;
      indexOfAlphabet[(int) tolower(amino[j])] = j;
    }
  }
  else {
    for (int j=0; j<NUM_NUCL+NUM_GAPS+1; j++) {
      indexOfAlphabet[(int) nucleic[j]] = j;
      indexOfAlphabet[(int) tolower(nucleic[j])] = j;
    }
  }
  for (int j=0; j<26; j++) {
    if (indexOfAlphabet[(int) general_Alphabet[j]] == -1) {
      indexOfAlphabet[(int) general_Alphabet[j]] = indexOfAlphabet[(int) 'X'];
      indexOfAlphabet[(int) tolower(general_Alphabet[j])] = indexOfAlphabet[(int) 'X'];
    }
  }
}
